/**
* ...
* @author starmonkey_811
* @version 0.1
*/

package  
{
	import flash.display.BitmapData;
	import flash.display.Shape;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;

	public class Kapla extends Sprite
	{
		private var _angle:Number = 0;
		private var _direction:int = 0;
		
		private var epaisseur:int = 10;
		private var largeur:int = 3 * epaisseur;
		private var longueur:int = 5* largeur;
		
		private var couleur:int;
		private var ombre:int;
		
		public static const HORIZONTAL:int = 0;
		public static const VERTICAL:int = 1;
		public static const TRANCHE:int = 2;
		public static const COULEUR:int = 0xEACC86;
		
		public function Kapla() 
		{
			couleur = Utils.degrade(COULEUR, Utils.ranColor(), Math.random()*0.1);
			ombre = Utils.degrade(couleur, 0, 0.2);
			dessine();
		}
		
		
		/* dessine le kapla selon son angle et son orientation */
		public function dessine():void
		{
			//il y a toujours deux cts visibles: un grand et un petit
			//leur largeur  l'cran varie delon l'angle
			//leur hauteur correspond  la troisieme dimension
			var petitCote:Number;
			var grandCote:Number;
			var autreCote:Number;
			if (_direction == HORIZONTAL) {
				petitCote = largeur;
				grandCote = longueur;
				autreCote = epaisseur;
			}else if (_direction == VERTICAL)
			{
				petitCote = epaisseur;
				grandCote = largeur;
				autreCote = longueur;
			}else {
				petitCote = epaisseur;
				grandCote = longueur;
				autreCote = largeur;
			}
			
			
			var em:Number = petitCote * Math.abs(Math.sin(angle));
			var eM:Number = grandCote * Math.abs(Math.cos(angle));
			var xm:Number;
			var xM:Number;
			
			var npx:Number;
			var ang:Number = angle;
			if (ang > Math.PI) ang -= Math.PI;
			if (angle < Math.PI / 2)
			{
				ang += Math.PI / 2;
				npx = -petitCote / 2 * Math.cos(ang);
				xM = npx + grandCote / 2 * Math.cos(ang + Math.PI/2);
				xm = xM + eM;
			}else {
				npx = grandCote / 2 * Math.cos(ang);
				
				xm = npx - petitCote / 2 * Math.cos(ang + Math.PI/2);
				xM = xm + em;
			}
			
			
			graphics.clear();
			//dessine les faces
			//petit
			graphics.beginFill(Utils.degrade(couleur, ombre, Math.abs(Math.cos(angle))));
			graphics.drawRect(xm, 0, em, autreCote);
			graphics.endFill();
			
			//grand
			graphics.beginFill(Utils.degrade(couleur, ombre, Math.abs(Math.sin(angle))));
			graphics.drawRect(xM, 0, eM, autreCote);
			graphics.endFill();
			
			//dessines les lignes
			graphics.lineStyle(1);
			graphics.moveTo(xm+Math.random()*3-1.5, Math.random()*3-1.5);
			graphics.lineTo(xm+Math.random()*3-1.5 + em, Math.random()*3-1.5);
			graphics.lineTo(xm+Math.random()*3-1.5 + em, autreCote + Math.random()*3-1.5);
			graphics.lineTo(xm + Math.random() * 3-1.5, autreCote + Math.random() * 3-1.5);
			graphics.lineTo(xm + Math.random() * 3 - 1.5, Math.random() * 3 - 1.5);
			
			graphics.moveTo(xM+Math.random()*3-1.5, Math.random()*3-1.5);
			graphics.lineTo(xM+Math.random()*3-1.5 + eM, Math.random()*3-1.5);
			graphics.lineTo(xM+Math.random()*3-1.5 + eM, autreCote + Math.random()*3-1.5);
			graphics.lineTo(xM + Math.random() * 3-1.5, autreCote + Math.random() * 3-1.5);
			graphics.lineTo(xM+Math.random()*3-1.5, Math.random()*3-1.5);
		}
		
		
		
		
		
		/* consultation/configuration de la direction du kapla (vertical, horizontal...) */
		public function set direction(dir:int):void
		{
			if (dir < 0) dir = 2;
			else if (dir > 2) dir = 0;
			_direction = dir;
		}
		
		public function get direction():int
		{
			return _direction;
		}
		
		/* consultation/configuration de l'angle de revolution */
		public function set angle(ang:Number):void
		{
			_angle = ang % Math.PI;
			if (_angle < 0) _angle = _angle + 2 * Math.PI;
			dessine();
		}
		
		public function get angle():Number
		{
			return _angle;
		}
		
		
	}
	
}
