package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.geom.Rectangle;
	import flash.utils.getTimer;
	
	public class Main extends Sprite
	{
		
		/* contient les kaplas stockes */
		private var kaplas:/*Kapla*/Array;
		/* kapla en cours de deplacement */
		private var kapla:Kapla;
		/* displayObject dans lequel les kaplas sont crees */
		private var conteneur:Sprite
		/* stocke l'etat des touches */
		private var keys:/*Boolean*/Array;
		/* timer pour ne pas changer trop vite d'orientation */
		private var timerDir:int = 0;
		
		/* vitesses du kapla (laterale, descente, revolution) */
		private var vx:Number = 5;
		private var vy:Number = 3;
		private var va:Number = Math.PI / 45;
		
		
		public function Main():void
		{
			keys = new Array();
			conteneur = new Sprite();
			conteneur.y = stage.stageHeight
			conteneur.graphics.lineTo(1, 1);
			addChild(conteneur);
			kaplas = new Array();
			addKapla();
			addEventListener(Event.ENTER_FRAME, deplace);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyHandler);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyHandler);
		}
		
		
		/* cree un kapla. si un kapla est dj en mouvement, il ne sera plus deplace */
		private function addKapla(event:Event = null):void
		{
			kapla = new Kapla();
			kapla.direction = Math.round(Math.random()*2);
			kapla.angle = Math.random() * Math.PI;
			kapla.x = Math.random() * Math.max(stage.stageWidth, conteneur.width) - conteneur.getBounds(conteneur).x;
			
			//kapla.y = -conteneur.height - 3 * kapla.height;
			var ymin:Number = 0;
			var n:int = kaplas.length;
			while (n--)
			{
				ymin = Math.min(ymin, kaplas[n].y);
			}
			kapla.y = ymin - 400;
			conteneur.addChild(kapla);
		}
		
		
		
		/* deplace le kapla et actualise le dessin de l'ensemble des kaplas */
		private function deplace(event:Event = null):void
		{
			gotoAndTestPos("y", kapla.y + vy);
			reactionClavier();
			refreshDisplay();
			resize();
		}
		
		
		
		/* passe au kapla suivant. implique l'arret du kapla en cours */
		private function nextKapla():void
		{
			kaplas.push(kapla);
			addKapla();
		}
		
		
		
		/**
		 * teste si la nouvelle position du kapla lui permet de bouger, le stoppe etc... 
		 * @param	prop nom de la propriete affectee
		 * @param	newValue nouvelle valeur pour cette propriete
		 */
		private function gotoAndTestPos(prop:String, newValue:*):void
		{
			var oldValue:* = kapla[prop];
			kapla[prop] = newValue;
			
			//trace(prop);
			var next:Boolean = false;
			
			var n:int = kaplas.length;
			
			if (prop == "x")
			{
				while (n--)
				{
					if (kapla.hitTestObject(kaplas[n]))
					{
						if (oldValue > newValue)
						{
							kapla.x = kaplas[n].x + kaplas[n].width / 2 + kapla.width / 2;
						}else {
							kapla.x = kaplas[n].x - kaplas[n].width / 2 - kapla.width /2
						}
					}
				}
			}else if (prop == "y")
			{
				while (n--)
				{
					if (kapla.hitTestObject(kaplas[n]) && (oldValue + kapla.height) < kaplas[n].y)
					{
						kapla.y = kaplas[n].y - kapla.height;
						next = true;
					}
				}
				if (newValue + kapla.height > 0)
				{
					kapla.y = - kapla.height;
					nextKapla();
				}
			}else if (prop == "direction" || prop == "angle")
			{
				while (n--)
				{
					//si on touche, la position n'est pas valide donc on revient  l'ancienne
					if (kapla.hitTestObject(kaplas[n]))kapla[prop] = oldValue;
				}
			}else {
				trace("ouch!");
			}
			
			if (next) nextKapla();
		}
		
		
		
		/* actualise le dessin de l'ensemble des kaplas */
		private function refreshDisplay():void
		{
			var n:int = kaplas.length;
			while (n--) kaplas[n].dessine();
			kapla.dessine();
		}
		
		
		/* redimmensionne le conteneur pour faire apparaitre l'integralite des kaplas */
		private function resize():void
		{
			conteneur.width = Math.min(stage.stageWidth - 20, conteneur.width);
			conteneur.scaleY = conteneur.scaleX;
			conteneur.height = Math.min(stage.stageHeight *5.5/6, conteneur.height);
			conteneur.scaleX = conteneur.scaleY;
			var rect:Rectangle = conteneur.getBounds(conteneur);
			conteneur.x = - Math.min(0, rect.x - 10) * conteneur.scaleX;
		}
		
		
		/* determine les touches enfonces ou relachees */
		private function keyHandler(event:KeyboardEvent):void
		{
			switch(event.type)
			{
				case KeyboardEvent.KEY_DOWN:
					keys[event.keyCode] = true;
					break;
				case KeyboardEvent.KEY_UP:
					keys[event.keyCode] = false;
					break;
			}
		}
		
		
		/* gere le comportement du kapla en cours selon les touches enfoncees */
		private function reactionClavier():void
		{
			if (keys[65])gotoAndTestPos("angle", kapla.angle + va);
			else if (keys[69]) gotoAndTestPos("angle", kapla.angle - va);
			
			if (keys[81])gotoAndTestPos("x", kapla.x - vx);
			else if (keys[68]) gotoAndTestPos("x", kapla.x + vx);
			
			if (keys[90] && (getTimer() - timerDir) > 100) 
			{
				gotoAndTestPos("direction", kapla.direction - 1);
				timerDir = getTimer();
			}else if (keys[83] && (getTimer() - timerDir) > 100)
			{
				gotoAndTestPos("direction", kapla.direction + 1);
				timerDir = getTimer();
			}
		}
	}
}